

{-----------------------------------------------------------------------------
 Unit Name: Antialiasing
 Project Name : Superficies
 Author:    Angel Montesinos Amilibia
 05/02/02
 Purpose:  antialiasing the contour of a surface
-----------------------------------------------------------------------------}
{

Superficies, workshop for the geometry of surfaces
Copyright (C) 2002 Angel Montesinos Amilibia

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation,Inc.,
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The source code, documentation, and examples may be freely downloaded from
     < ftp://topologia.geomet.uv.es/pub/montesin/Superficies_W32 >

You can email me to:
     montesin@uv.es

Or write me to:
     Angel Montesinos
     Departamento de Geometria y Topologia
     Dr. Moliner, 50
     46100 Burjasot (Valencia)
     Spain

}



unit Antialiasing;
interface
uses
{$IFDEF MSWINDOWS}
  Forms,
{$ENDIF}
{$IFDEF LINUX}
  QForms,
{$ENDIF}
  Globals;

procedure Antialiase(var Map: Colormapptr);

implementation
uses
  sysutils;
const
  whiteNeg = 199;
  whitePos = 99;

type
  ColorLine = array[0..24] of Integer;

var
  AAMap: ColorMapPtr;

procedure Scanrow(Map: Colormapptr; N: Integer);
var
  h, hIni, top, i, jump: Integer;
  color, half, a, b, c, cc, cb: Double;
begin {1}
  h := 1;
  top := kWidthMinus1;
  while h < top do
  begin {2}
    if (map^[h, n] = 0) then
    begin {3}
      if (map^[h, n - 1] <> 0) then
        jump := -1
      else if (map^[h, n + 1] <> 0) then
        jump := 1
      else
      begin {4}
        h := h + 1;
        continue;
      end; {4}
      if (map^[h - 1, n + jump] = 0) then
      begin {4}
        hIni := h;
        repeat
          h := h + 1
        until (map^[h, n] <> 0) or (map^[h, n + jump] = 0) or (h =
          top);
        if (map^[h, n + jump] = 0) then
        begin {5}
          half := 3.6 / sqr(h - hIni);
          a := (0.5 - hIni) * (h - 0.5) * half;
          b := (h + hIni - 1) * half;
          c := -half;
          for i := hIni to h - 1 do
          begin {6}
            color := map^[i, n + jump];
            cc := a + i * (b + c * i);
            cb := 1 - cc;
            if color > 99 then
              AAMap^[i, n] := round(color * cc + whiteNeg * cb)
            else
              AAMap^[i, n] := round(color * cc + whitePos * cb)
          end; {6}
        end {5}
        else
        begin {5}
          if (map^[h, n] = 0) then
            h := h + 1;
          if (h - hIni) > 1 then
          begin {6}
            half := h - hIni;
            a := (h - 0.5) / half;
            b := -1 / half;
            for i := hIni to (h - 1) do
            begin {7}
              color := map^[i, n + jump];
              cb := a + b * i;
              cc := 1 - cb;
              if color > 99 then
                AAMap^[i, n] := round(color * cc + whiteNeg * cb)
              else
                AAMap^[i, n] := round(color * cc + whitePos * cb)
            end; {7}
          end; {6}
        end; {5}
      end {if (Ptr(h+jump-1)^ = 0)} {4}
      else
      begin {4}
        hIni := h;
        repeat
          h := h + 1
        until (map^[h, n] <> 0) or (map^[h, n + jump] = 0) or (h =
          top);
        if (map^[h, n + jump] = 0) or (h = top) then
        begin {5}
          if (h = top) then
            h := h + 1;
          if (h - hIni) > 1 then
          begin {6}
            half := h - hIni;
            a := (h - 0.5) / half;
            b := -1 / half;
            for i := hIni to (h - 1) do
            begin {7}
              color := map^[i, n + jump];
              cc := a + b * i;
              cb := 1 - cc;
              if color > 99 then
                AAMap^[i, n] := round(color * cc + whiteNeg * cb)
              else
                AAMap^[i, n] := round(color * cc + whitePos * cb)
            end; {7}
          end; {6}
        end {5}
        else if (map^[h, n + jump] <> 0) then
        begin {5}
          half := 3.6 / sqr(h - hIni);
          a := (0.5 - hIni) * (h - 0.5) * half;
          b := (h + hIni - 1) * half;
          c := -half;
          for i := hIni to h - 1 do
          begin {6}
            color := map^[i, n + jump];
            cb := a + i * (b + c * i);
            cc := 1 - cb;
            if color > 99 then
              AAMap^[i, n] := round(color * cc + whiteNeg * cb)
            else
              AAMap^[i, n] := round(color * cc + whitePos * cb)
          end; {6}
        end {5}
        else
      end {if (Ptr(h+jump-1)^ <> 0)} {4}
    end {3}
    else
      h := h + 1;
  end; {2}
end; {1}

procedure Scancolumn(Map: Colormapptr; N: Integer);
var
  v, vIni, top, i, jump: Integer;
  color, half, a, b, c, cc, cb: Double;
begin {1}
  v := 1;
  top := kHeightMinus1;
  while v < top do
  begin {2}
    if (map^[n, v] = 0) then
    begin {3}
      if (map^[n - 1, v] <> 0) then
        jump := -1
      else if (map^[n + 1, v] <> 0) then
        jump := 1
      else
      begin {4}
        inc(v);
        continue;
      end; {4}
      if (map^[n + jump, v - 1] = 0) then
      begin {4}
        vIni := v;
        repeat
          inc(v)
        until (map^[n, v] <> 0) or (map^[n + jump, v] = 0) or (v =
          top);
        if (map^[n + jump, v] = 0) then
        begin {5}
          half := 3.6 / sqr(v - vIni);
          a := (0.5 - vIni) * (v - 0.5) * half;
          b := (v + vIni - 1) * half;
          c := -half;
          for i := vIni to v - 1 do
          begin {6}
            color := map^[n + jump, i];
            cc := a + i * (b + c * i);
            cb := 1 - cc;
            if color > 99 then
              AAMap^[n, i] := round(color * cc + whiteNeg * cb)
            else
              AAMap^[n, i] := round(color * cc + whitePos * cb)
          end; {6}
        end {5}
        else
        begin {5}
          if (map^[n, v] = 0) then
            inc(v);
          if (v - vIni) > 0 then
          begin {6}
            half := v - vIni;
            a := (v - 0.5) / half;
            b := -1 / half;
            for i := vIni to (v - 1) do
            begin {7}
              color := map^[n + jump, i];
              cb := a + b * i;
              cc := 1 - cb;
              if color > 99 then
                AAMap^[n, i] := round(color * cc + whiteNeg * cb)
              else
                AAMap^[n, i] := round(color * cc + whitePos * cb)
            end; {7}
          end; {6}
        end; {5}
      end {4}
      else
      begin {4}
        vIni := v;
        repeat
          inc(v)
        until (map^[n, v] <> 0) or (map^[n + jump, v] = 0) or (v =
          top);
        if (map^[n + jump, v] = 0) or (v = top) then
        begin {5}
          if (v = top) then
            inc(v);
          if (v - vIni) > 0 then
          begin {6}
            half := v - vIni;
            a := (v - 0.5) / half;
            b := -1 / half;
            for i := vIni to (v - 1) do
            begin {7}
              color := map^[n + jump, i];
              cc := a + b * i;
              cb := 1 - cc;
              if color > 99 then
                AAMap^[n, i] := round(color * cc + whiteNeg * cb)
              else
                AAMap^[n, i] := round(color * cc + whitePos * cb)
            end; {7}
          end; {6}
        end {5}
        else if (map^[n + jump, v] <> 0) then
        begin {5}
          half := 3.6 / sqr(v - vIni);
          a := (0.5 - vIni) * (v - 0.5) * half;
          b := (v + vIni - 1) * half;
          c := -half;
          for i := vIni to v - 1 do
          begin {6}
            color := map^[n + jump, i];
            cb := a + i * (b + c * i);
            cc := 1 - cb;
            if color > 99 then
              AAMap^[n, i] := round(color * cc + whiteNeg * cb)
            else
              AAMap^[n, i] := round(color * cc + whitePos * cb)
          end; {6}
        end {5}
        else
      end {4}
    end {3}
    else
      inc(v);
  end; {2}
end; {1}

procedure Antialiase(var Map: Colormapptr);
var
  n, i, j: Integer;
begin {1}
  for i := 0 to kWidthMinus1 do
    for j := 0 to kHeightMinus1 do
      AAMap^[i, j] := map^[i, j];
  for n := 1 to kHeight - 2 do
    ScanRow(map, n);
  for n := 1 to kWidth - 2 do
    ScanColumn(map, n);
  for i := 0 to kWidthMinus1 do
    for j := 0 to kHeightMinus1 do
      map^[i, j] := AAmap^[i, j];
end; {1}

procedure Createmap;
begin {1}
  New(AAMap);
  if AAMap = nil then
    Application.Terminate;
end; {1}

procedure Disposemap;
begin {1}
  if AAMap <> nil then
    Dispose(AAMap);
end; {1}

initialization
  CreateMap;

finalization
  DisposeMap;

end.
