

{-----------------------------------------------------------------------------
 Unit Name: FSurface
 Project Name : Superficies
 Author:    Angel Montesinos Amilibia
 05/02/02
 Purpose: TSurface is the main form of the application where almost everything
    happens.
-----------------------------------------------------------------------------}
{

Superficies, workshop for the geometry of surfaces
Copyright (C) 2002 Angel Montesinos Amilibia

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation,Inc.,
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The source code, documentation, and examples may be freely downloaded from
     < ftp://topologia.geomet.uv.es/pub/montesin/Superficies_W32 >

You can email me to:
     montesin@uv.es

Or write me to:
     Angel Montesinos
     Departamento de Geometria y Topologia
     Dr. Moliner, 50
     46100 Burjasot (Valencia)
     Spain

}



unit FSurface; //made translation

interface

uses
  SysUtils, Classes
{$IFDEF MSWINDOWS}
  , Windows, Forms, Graphics, Controls, Dialogs, clipbrd,
  Menus, ExtCtrls, ComCtrls, StdCtrls, Buttons, StdActns, ActnList,
{$ENDIF}
{$IFDEF LINUX}
  , Variants, QGraphics, QControls, QForms, QDialogs, Types, QMenus,
  QExtCtrls, QComCtrls, QStdCtrls, QButtons, QStdActns, QActnList, QClipbrd,
{$ENDIF}
  Globals;

type
  TSurface = class(TForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    AboutSuperficies1: TMenuItem;
    N1: TMenuItem;
    NewParametricSurface1: TMenuItem;
    NewImplicitSurface1: TMenuItem;
    NewPseudoRiemannianPlane1: TMenuItem;
    NewTube1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Refresh1: TMenuItem;
    N3: TMenuItem;
    Print1: TMenuItem;
    N4: TMenuItem;
    Quit1: TMenuItem;
    Preferences1: TMenuItem;
    EuclideanSpace1: TMenuItem;
    MinkowskiSpace1: TMenuItem;
    N5: TMenuItem;
    ShowUnitCircle1: TMenuItem;
    DrawCube1: TMenuItem;
    N6: TMenuItem;
    DrawOnBothSides1: TMenuItem;
    DrawOnNormalSide1: TMenuItem;
    DrawOntheOtherSide1: TMenuItem;
    N7: TMenuItem;
    ObverseColor: TMenuItem;
    ReverseColor: TMenuItem;
    N8: TMenuItem;
    ViewMode1: TMenuItem;
    FixMove: TMenuItem;
    Standard1: TMenuItem;
    ColoredStereoPair1: TMenuItem;
    WireframeMono1: TMenuItem;
    WireframeStereo1: TMenuItem;
    WireframeStereoPair1: TMenuItem;
    Geometry1: TMenuItem;
    CoordinateLines1: TMenuItem;
    N9: TMenuItem;
    LightRays1: TMenuItem;
    Geodesics1: TMenuItem;
    ExponentialMap1: TMenuItem;
    GeodesicbetweenPoints1: TMenuItem;
    GeodesicBall1: TMenuItem;
    LinesofConstantGeodCurv1: TMenuItem;
    ParallelTransport1: TMenuItem;
    N10: TMenuItem;
    CurvatureLines1: TMenuItem;
    AsymptoticLines1: TMenuItem;
    N11: TMenuItem;
    Clipping1: TMenuItem;
    NormalSection1: TMenuItem;
    DrawMesh1: TMenuItem;
    MESHLINENUMBER1: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N61: TMenuItem;
    N91: TMenuItem;
    N121: TMenuItem;
    N161: TMenuItem;
    N251: TMenuItem;
    N361: TMenuItem;
    N491: TMenuItem;
    N641: TMenuItem;
    N1001: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    Quit: TAction;
    ColorDialog1: TColorDialog;
    DrawButton: TSpeedButton;
    Drawing2D: TPaintBox;
    Drawing3D: TPaintBox;
    f1Label: TLabel;
    f2Label: TLabel;
    f3Label: TLabel;
    f4Label: TLabel;
    f1Edit: TMemo;
    f2Edit: TMemo;
    f3Edit: TMemo;
    f4Edit: TMemo;
    uMinEdit: TEdit;
    uLabel: TLabel;
    uMaxEdit: TEdit;
    vMinEdit: TEdit;
    vLabel: TLabel;
    vMaxEdit: TEdit;
    wMinEdit: TEdit;
    wLabel: TLabel;
    wMaxEdit: TEdit;
    InfoBar: TStatusBar;
    xEqLabel: TLabel;
    yEqLabel: TLabel;
    zEqLabel: TLabel;
    uEqLabel: TLabel;
    vEqLabel: TLabel;
    HLabel: TLabel;
    k1Label: TLabel;
    k2Label: TLabel;
    KLabel: TLabel;
    CoordLabel: TLabel;
    CurvLabel: TLabel;
    InfoLabel: TLabel;
    InfoPanel: TMemo;
    StopButton: TSpeedButton;
    N2: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    CoordPanel: TLabel;
    CurvPanel: TLabel;
{$IFDEF MSWINDOWS}
    PrintDialog1: TPrintDialog;
    SaveAsBitmap1 : TMenuItem;
{$ENDIF}
    procedure InitMenus;
    procedure NotAlreadyDrawnMenus;
    procedure Initialize(sender: TObject);
    procedure ExecuteQuit(Sender: TObject);
    procedure InitEditFields(strs: EditFStrings);
    procedure ForgetPastData;
    procedure ChangeSurfaceType(Sender: TObject);
    procedure InitParametricSurfaceOrTubeForm;
    procedure InitImplicitSurfaceForm;
    procedure InitPseudoRiemPlaneForm;

    procedure OnDrawButtonClick(Sender: TObject);

    procedure AboutSuperf(Sender: TObject);
    procedure Inform(m: AnsiString);
    procedure OnOpen(Sender: TObject);

    procedure PaintBox(Sender: TObject);
    procedure OnSave(Sender: TObject);
    procedure OnSaveAs(Sender: TObject);
    function CloseCurrentSurface(Sender: TObject): Boolean;
    procedure CloseQueryClick(Sender: TObject; var CanClose: Boolean);

    procedure OnSignatureClick(Sender: TObject);
    procedure OnShowUnitCircle(Sender: TObject);
    procedure OnDrawCube(Sender: TObject);
    procedure OnSidesClick(Sender: TObject);
    procedure OnPickColor(Sender: TObject);
    procedure ChangeViewMode(Sender: TObject);
    procedure OnGeometryItem(Sender: TObject);
    procedure OnMeshNumber(Sender: TObject);
    procedure ShowCoordinates;
    procedure ShowCurvatures(calculateThem: Boolean);
    function ComputeCurPointsFrom2D: Boolean;
    function ComputeCurPointsFrom3D: Boolean;
    procedure ResetPoints(sender: TPaintBox; x, y: Integer; firstTime:
      Boolean);
    function ShouldTrackMouse(sender: TPaintBox): Boolean;
    procedure OnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DrawXCrossUnitCircleEtc(sender: TPaintBox);
    procedure RepaintXCrossUnitCircleEtc(sender: TPaintBox);
    procedure DoDraggingMouse(sender: TPaintBox; Shift: TShiftState);
    procedure OnMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DoAfterMouseUp(Sender: TPaintBox; Shift: TShiftState; X, Y:
      Integer);
    procedure OnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OnRefresh(Sender: TObject);
    procedure InitWatch;
    procedure EndWatch;
    procedure OnStopButton(Sender: TObject);
    procedure OnMemoFocus(Sender: TObject);
    procedure MovingMouseInForm(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ClickOnMenuBarExecute(Sender: TObject);
    procedure OnEditFieldChange(Sender: TObject);
    procedure OnPrintMenu(Sender: TObject);
    procedure OnSaveAsBitmap(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure EraseBmpAndSetFlags;

var
  Surface: TSurface;

implementation

{$IFDEF MSWINDOWS}
{$R *.dfm}
{$ENDIF}
{$IFDEF LINUX}
{$R *.xfm}
{$ENDIF}

uses
{$IFDEF MSWINDOWS}
  Printers,
{$ENDIF}
{$IFDEF LINUX}
  QPrinters,
{$ENDIF}
  FAbout, ResStrings, ReadForms, InitParams, DrawParamSurf,
  DrawImplicitSurf, BasicRiemUtils, Antialiasing, FileInOut, Utilities,
  ParametricUtils, ImplicitUtils, FRunKut, ParalTransport, SecondOrderCurves,
  ManageClips, FSelectToPrint, FineDrawing;

procedure TSurface.InitMenus;
var
  i: Integer;
  isNotPseudoRiemannian: Boolean;
begin
  for i := 0 to File1.Count - 1 do
    File1.Items[i].Enabled := True;
  File1.Items[ord(gType) + 2].Enabled := False;
  isNotPseudoRiemannian := (gType <> PseudoRiemannian);

  Preferences1.Enabled := True;
  for i := 0 to Preferences1.Count - 1 do
    Preferences1.Items[i].Enabled := isNotPseudoRiemannian;
  ShowUnitCircle1.Enabled := (gType <> Implicit);
  ShowUnitCircle1.Caption := eShowUnitCircle;
  DrawCube1.Caption := eDrawCube;
  DrawOnBothSides1.checked := True;
  DrawOnNormalSide1.Checked := False;
  DrawOnTheOtherSide1.Checked := False;
  gSideToDrawOn := 2;
  FixMove.Enabled := (gType = Parametric) or (gType = Tube);
  gMode := Standard;
  ViewMode1.Items[0].Checked := True;
  for i := 1 to ViewMode1.Count - 1 do
    ViewMode1.Items[i].Checked := False;
  Geometry1.Enabled := True;
  for i := 0 to 8 do begin
    Geometry1.Items[i].Enabled := True;
    Geometry1.Items[i].Checked := False;
  end;
  for i := 10 to 14 do begin
    Geometry1.Items[i].Enabled := isNotPseudoRiemannian;
    Geometry1.Items[i].Checked := False;
  end;
  gGeomOption := Nothing;
  EuclideanSpace1.Checked := (gEpsilon = 1);
  MinkowskiSpace1.Checked := (gEpsilon <> 1);
  LightRays1.Enabled := (not isNotPseudoRiemannian) or (gEpsilon = -1);
  ParallelTransport1.Enabled := (gType <> Implicit);

  DrawMesh1.Enabled := isNotPseudoRiemannian;
  if gClips <> nil then
    StopButton.caption := eNoClips
  else
    StopButton.caption := ''; ;
  StopButton.Enabled := (gClips <> nil);
end;

procedure TSurface.NotAlreadyDrawnMenus;
var
  i: Integer;
begin
  Preferences1.Enabled := False;
  Geometry1.Enabled := False;
  DrawMesh1.Enabled := False;
  for i := 7 to File1.count - 2 do
    File1.Items[i].Enabled := False;
end;


procedure TSurface.Initialize(sender: TObject);
begin
  if Assigned(Surface) then
    with Surface do begin
      Drawing3D.Width := kWidth;
      Drawing3D.Height := kHeight;
      Drawing3D.ControlStyle := Drawing3D.ControlStyle + [csOpaque,
        csFixedHeight,
        csFixedWidth];
      Drawing2D.Width := kWidth;
      Drawing2D.Height := kHeight;
      Drawing2D.ControlStyle := Drawing2D.ControlStyle + [csOpaque,
        csFixedHeight,
        csFixedWidth];
    end;
end;

procedure TSurface.ExecuteQuit(Sender: TObject);
var
  cc: Boolean;
begin
  if gBusy then Exit;
  cc := False;
  OnCloseQuery(sender, cc);
  if cc then
    Application.Terminate;
end;

procedure EraseBmpAndSetFlags;
begin
  gStdBmp.Canvas.FillRect(gRect);
  gMovingBmp.Canvas.FillRect(gRect);
  gThereIsX2D := False;
  gThereIsX3D := False;
  gThereIsCross2D := False;
  gThereIsCross3D := False;
  gThereIsUnitConic := 0;
end;



procedure TSurface.InitEditFields(strs: EditFStrings);
begin
  f1Edit.text := strs[1];
  f2Edit.text := strs[2];
  f3Edit.text := strs[3];
  f4Edit.text := strs[4];
  uMinEdit.text := strs[5];
  uMaxEdit.text := strs[6];
  vMinEdit.text := strs[7];
  vMaxEdit.text := strs[8];
  wMinEdit.text := strs[9];
  wMaxEdit.text := strs[10];
end;

procedure TSurface.ForgetPastData;
begin
  gGotProjParams := False;
  gSaved := False;
  gPathAndName := '';
  gTitle := eUntitled;
  gVersion := kVersion;
  gClips := nil;
  gClipTop := -1;
  gNewClip.u[1] := 0;
  gNewClip.u[2] := 0;
  gNewClip.u[3] := 1;
  gNewClip.a := 0;
end;

procedure TSurface.ChangeSurfaceType(Sender: TObject);
var
  newType: SurfaceType;
begin
  if gBusy then
    Exit;
  if sender = nil then begin
    InitNewSurfaceVars;
    InitEditFields(gSurfaceStr);
    newType := gType;
  end
  else begin
    newType := SurfaceType(TMenuItem(sender).tag);
    if (newType <> gType) and not CloseCurrentSurface(Sender) then
      Exit;
    InitNewSurfaceVars;
    NotAlreadyDrawnMenus;
    ForgetPastData;
  end;
  File1.Items[ord(gType) + 2].Enabled := True;
  File1.Items[ord(newType) + 2].Enabled := False;
  gType := newType;
  case gType of
    Parametric, Tube:
      InitParametricSurfaceOrTubeForm;
    Implicit:
      InitImplicitSurfaceForm;
    PseudoRiemannian:
      InitPseudoRiemPlaneForm;
  end;
  SetWiresData;
end;

procedure TSurface.InitParametricSurfaceOrTubeForm;
begin
  Width := 814;
  InfoLabel.Visible := False;
  InfoPanel.Visible := False;
  InfoPanel.Enabled := False;
  if gTitle = eUntitled then begin
    if gType = Parametric then
      caption := eParamSurface
    else
      caption := eTube;
  end
  else
    caption := gTitle;
  if gType = Parametric then
    Height := 553
  else
    Height := 561;

  with Drawing3D do begin
    Left := 404;
    Visible := True;
    Enabled := True;
    Invalidate;
  end;
  with Drawing2D do begin
    Left := 2;
    Visible := True;
    Enabled := True;
    Invalidate;
  end;
  with StopButton do begin
    Left := 531;
    Top := 416;
    if gClips <> nil then
      caption := eNoClips
    else
      caption := ''; ;
    Enabled := (gClips <> nil);
  end;
  with DrawButton do begin
    Left := 531;
    Top := 448;
    Enabled := True;
    Caption := eDWDrawIt;
  end;
  f1Edit.Height := 21;
  f2Label.Visible := True;
  f2Edit.Visible := True;
  f3Label.Visible := True;
  f3Edit.Visible := True;
  f3Edit.Enabled := True;
  if gType = Parametric then begin
    f1Label.Caption := 'x(u,v) =';
    uLabel.Caption := '< u <';
    f2Label.Caption := 'y(u,v) =';
    vMinEdit.Visible := True;
    vLabel.Visible := True;
    vLabel.Caption := '< v <';
    vMaxEdit.Visible := True;
    f3Label.Caption := 'z(u,v) =';
    wMinEdit.Visible := False;
    wMinEdit.Enabled := False;
    wLabel.Visible := True;
    wLabel.Caption := 'Grid density';
    wLabel.Left := 403;
    wMaxEdit.Visible := True;
    wMaxEdit.Enabled := True;
    f4Label.Visible := False;
    f4Edit.Visible := False;
    f4Edit.Enabled := False;
    uEqLabel.Caption := 'u =';
    vEqLabel.Caption := 'v =';
    if (gTitle = eUntitled) then
      InitEditFields(gStrInitParametric)
    else
      InitEditFields(gSurfaceStr)

  end
  else begin
    f1Label.Caption := 'x(t) =';
    uLabel.Caption := '< t <';
    f2Label.Caption := 'y(t) =';
    vMinEdit.Visible := False;
    vLabel.Visible := False;
    vMaxEdit.Visible := False;
    f3Label.Caption := 'z(t) =';
    wMinEdit.Visible := False;
    wLabel.Visible := False;
    wMaxEdit.Visible := False;
    f4Label.Visible := True;
    f4Label.Caption := 'r(t) =';
    f4Edit.Visible := True;
    f4Edit.Enabled := True;
    uEqLabel.Caption := 't =';
    if (gTitle <> eUntitled) then
      InitEditFields(gSurfaceStr)
    else
      InitEditFields(gStrInitTube);
  end;
  with CurvPanel do begin
    Left := 744;
    Top := 423;
    Height := 52;
    caption := '';
  end;
  CurvLabel.Left := 718;
  CurvLabel.Top := 405;
  KLabel.Left := 718;
  KLabel.Top := 422;
  with HLabel do begin
    Left := 718;
    Top := 435;
    Visible := True;
  end;
  with k1Label do begin
    Left := 718;
    Top := 448;
    Visible := True;
  end;
  with k2Label do begin
    Left := 718;
    Top := 461;
    Visible := True;
  end;
  CoordLabel.Left := 620;
  CoordLabel.Top := 405;
  with CoordPanel do begin
    Left := 644;
    Top := 422;
    caption := '';
    Height := 65;
  end;
  xEqLabel.Left := 620;
  xEqLabel.Top := 447;
  xEqLabel.Visible := True;
  yEqLabel.Left := 620;
  yEqLabel.Top := 460;
  yEqLabel.Visible := True;
  zEqLabel.Left := 620;
  zEqLabel.Top := 473;
  zEqLabel.Visible := True;
  uEqLabel.Left := 620;
  uEqLabel.Top := 421;
  uEqLabel.Visible := True;
  vEqLabel.Left := 620;
  vEqLabel.Top := 434;
  vEqLabel.Visible := True;
  InfoBar.Visible := True;
  InfoBar.Enabled := True;
  InfoBar.SimpleText := '';
end;

procedure TSurface.InitImplicitSurfaceForm;
begin
  if gTitle = eUntitled then
    caption := eImplicitSurface
  else
    caption := gTitle;
  with Drawing2D do begin
    Visible := False;
    Enabled := False;
  end;
  f2Label.Visible := False;
  f2Edit.Visible := False;
  f3Label.Visible := False;
  f3Edit.Visible := False;
  f4Label.Visible := False;
  f4Edit.Visible := False;
  f4Edit.Enabled := False;
  uEqLabel.Visible := False;
  vEqLabel.Visible := False;
  InfoBar.Visible := False;
  InfoBar.Enabled := False;
  with Drawing3D do begin
    Left := 2;
    Visible := True;
    Enabled := True;
    Invalidate;
  end;
  Height := 520;
  Width := 530;
  with StopButton do begin
    Left := 422;
    Top := 340;
    if gClips <> nil then
      caption := eNoClips
    else
      caption := ''; ;
    Enabled := (gClips <> nil);
  end;
  with DrawButton do begin
    Left := 422;
    Top := 373;
    Caption := eDWDrawIt;
    Enabled := True;
  end;
  f1Label.Caption := 'f(x,y,z)=';
  f1Edit.Height := 68;
  uLabel.Caption := '< x <';
  vMinEdit.Visible := True;
  vLabel.Visible := True;
  vLabel.Caption := '< y <';
  vMaxEdit.Visible := True;
  wMinEdit.Visible := True;
  wMinEdit.Enabled := True;
  wLabel.Visible := True;
  wLabel.Caption := '< z <';
  wLabel.Left := 445;
  wMaxEdit.Visible := True;
  wMaxEdit.Enabled := True;
  if (gTitle <> eUntitled) then
    InitEditFields(gSurfaceStr)
  else
    InitEditFields(gStrInitImplicit);
  with CurvPanel do begin
    Left := 442;
    Top := 105;
    caption := '';
    Height := 52;
  end;
  CurvLabel.Left := 416;
  CurvLabel.Top := 86;
  KLabel.Left := 416;
  KLabel.Top := 104;
  with HLabel do begin
    Left := 416;
    Top := 117;
    Visible := True;
  end;
  with k1Label do begin
    Left := 416;
    Top := 130;
    Visible := True;
  end;
  with k2Label do begin
    Left := 416;
    Top := 143;
    Visible := True;
  end;
  InfoLabel.Visible := True;
  InfoPanel.Visible := True;
  InfoPanel.Enabled := True;
  CoordLabel.Left := 416;
  CoordLabel.Top := 2;
  with CoordPanel do begin
    Left := 436;
    Top := 21;
    caption := '';
    Height := 40;
  end;
  xEqLabel.Left := 416;
  xEqLabel.Top := 20;
  xEqLabel.Visible := True;
  yEqLabel.Left := 416;
  yEqLabel.Top := 33;
  yEqLabel.Visible := True;
  zEqLabel.Left := 416;
  zEqLabel.Top := 46;
  zEqLabel.Visible := True;
end;

procedure TSurface.InitPseudoRiemPlaneForm;
begin
  if gTitle = eUntitled then
    caption := ePseudoRPlane
  else
    caption := gTitle;
  Height := 516;
  Width := 534;
  with Drawing2D do begin
    Left := 2;
    Visible := True;
    Enabled := True;
    Drawing2D.Canvas.FillRect(gRect);
  end;
  with Drawing3D do begin
    Visible := False;
    Enabled := False;
  end;
  with StopButton do begin
    Left := 422;
    Top := 340;
    caption := '';
    enabled := False;
  end;
  with DrawButton do begin
    Left := 422;
    Top := 373;
    Enabled := True;
    Caption := eDWDrawIt;
  end;

  CoordLabel.Left := 416;
  CoordLabel.Top := 2;
  with CoordPanel do begin
    Left := 438;
    Top := 22;
    caption := '';
    Height := 26;
  end;
  uEqLabel.Left := 416;
  uEqLabel.Top := 21;
  uEqLabel.Caption := 'x =';
  uEqLabel.Visible := True;
  vEqLabel.Caption := 'y =';
  vEqLabel.Left := 416;
  vEqLabel.Top := 34;
  vEqLabel.Visible := True;

  with CurvPanel do begin
    Left := 438;
    Top := 104;
    Height := 18;
    caption := '';
  end;
  CurvLabel.Left := 416;
  CurvLabel.Top := 84;
  KLabel.Left := 416;
  KLabel.Top := 103;

  InfoBar.Visible := False;
  InfoBar.Enabled := False;
  wMinEdit.Visible := False;
  wMinEdit.Enabled := False;
  wLabel.Visible := False;
  wMaxEdit.Visible := False;
  wMaxEdit.Enabled := False;
  f4Label.Visible := False;
  f4Edit.Visible := False;
  f4Edit.Enabled := False;
  HLabel.Visible := False;
  k1Label.Visible := False;
  k2Label.Visible := False;
  xEqLabel.Visible := False;
  yEqLabel.Visible := False;
  zEqLabel.Visible := False;

  f1Label.Caption := 'E(x,y) =';
  f1Edit.Height := 21;
  uLabel.Caption := '< x <';
  f2Label.Visible := True;
  f2Label.Caption := 'F(x,y) =';
  f2Edit.Visible := True;
  f2Edit.Enabled := True;
  f3Label.Visible := True;
  f3Label.Caption := 'G(x,y) =';
  f3Edit.Visible := True;
  f3Edit.Enabled := True;
  vMinEdit.Visible := True;
  vLabel.Visible := True;
  vLabel.Caption := '< y <';
  vMaxEdit.Visible := True;
  if (gTitle <> eUntitled) then
    InitEditFields(gSurfaceStr)
  else
    InitEditFields(gStrInitPseudoRiemannian);

  InfoLabel.Visible := True;
  InfoPanel.Visible := True;
  InfoPanel.Enabled := True;
end;

procedure TSurface.OnDrawButtonClick(Sender: TObject);
var
  readingResult: Integer;
begin
  if gBusy then
    Exit;
  gBusy := True;
  if (sender = nil) or ((DrawButton.caption = eRedraw) and (gMode in
    gWireModes)) then
    readingResult := 1
  else if (DrawButton.caption = eClipIt) and (gGeomOption in [Clipping,
    NormalSection]) then begin
    AddNewClip;
    readingResult := 1;
    DrawButton.Caption := eRedraw;
  end
  else begin
    readingResult := ReadForm;
    if readingResult = 1 then begin
      InitNewSurfaceVars;
      InitializeSurfaceParameters(False);
    end;
  end;
  if readingResult = 1 then begin
    InitWatch;
    InitSavedLines;
    case gType of
      Parametric, Tube:
        gAlreadyDrawn := DrawParametricSurface;
      PseudoRiemannian:
        gAlreadyDrawn := DrawRiemannianCurvature;
      Implicit:
        gAlreadyDrawn := DrawImplicitSurface;
    else
      ;
    end;
    DrawButton.Caption := '';
    DrawButton.Enabled := False;
    EndWatch;
    gSaved := False;
    Drawing2D.invalidate;
    Drawing3D.invalidate;
    if gAlreadyDrawn then
      InitMenus
    else
      NotAlreadyDrawnMenus;
  end;
  gBusy := False;
end;

procedure TSurface.PaintBox(Sender: TObject);
  var
    cr :TRect;
begin
  if sender = Drawing3D then begin
    if (gMode in [Standard, Movable]) then begin
      Drawing3D.Canvas.Draw(0, 0, gStdBmp);
      if not (gGeomOption in [NormalSection, Clipping]) then begin
        DrawSavedLines(3);
        if gShowCube then
          DrawCube(Drawing3D.Canvas);
      end;
    end
    else
      Drawing3D.Canvas.Draw(0, 0, gMovingBmp);
    RepaintXCrossUnitCircleEtc(Drawing3D);
  end
  else begin
    cr := drawing2D.canvas.ClipRect;
    if gType = PseudoRiemannian then begin
      Drawing2D.Canvas.Draw(0, 0, gStdBmp);
    end
    else
      Drawing2D.Canvas.FillRect(gRect);
    if gMode = Standard then
      DrawSavedLines(2);
    RepaintXCrossUnitCircleEtc(Drawing2D);
  end;
  if (gMode = Standard) and (gGeomOption in [NormalSection, Clipping]) then
  begin
    Drawing3D.Canvas.Draw(0, 0, gStdBmp);
    if gType = Implicit then
      DrawCutImplicitSurface
    else
      DrawCutParamSurface(false);
  end;
end;

procedure TSurface.Inform(m: AnsiString);
begin
  if infoPanel.Visible then
    infoPanel.Text := m
  else
    infoBar.SimpleText := m;
end;



procedure TSurface.AboutSuperf(Sender: TObject);
begin
  if gBusy then Exit;
  with TAbout.Create(nil) do
  try
    ShowModal;
  finally
    Release;
  end;
end;


procedure TSurface.OnOpen(Sender: TObject);
var
  done: Boolean;
  pathAndName: AnsiString;
  readingResult: Integer;
begin
  if gBusy then Exit;
  done := False;
  if not CloseCurrentSurface(Sender) then
    Exit;
  OpenDialog1.Options := [ofFileMustExist, ofNoChangeDir];
  while not done do begin
    OpenDialog1.Filename := '';
    if OpenDialog1.Execute then begin
      pathAndName := OpenDialog1.FileName;
      gGotProjParams := ReadFromDisk(pathAndName);
      if gGotProjParams then begin
        gTitle := ExtracTitle(pathAndName);
        ChangeSurfaceType(nil);
        NotAlreadyDrawnMenus;
        readingResult := ReadForm;
        if readingResult <> 2 then begin
          InitializeSurfaceParameters(true);
          if gType = PseudoRiemannian then
            ReceiveColorMap(gStdBmp, gMap)
          else
            ReceiveColorMap(gStdBmp, gMap);
          gAlreadyDrawn := True;
          if (gType = Parametric) or (gType = Tube) then begin
            if gClips <> nil then
              ComputeZBufferWithClips
            else
              ComputeZBuffer;
          end;
          if gType <> PseudoRiemannian then
            ComputeCube;
          DrawButton.Enabled := False;
          DrawButton.caption := '';
          Drawing2D.invalidate;
          Drawing3D.invalidate;
        end;
        gBusy := False;
        gPathAndName := pathAndName;
        InitMenus;
      end;
      Done := True;
    end
    else
      done := True;
  end;
end;

procedure TSurface.OnSave(Sender: TObject);
begin
  if gBusy or (not gAlreadyDrawn) or gSaved then
    Exit;
  if gPathAndName = '' then
    OnSaveAs(sender)
  else
    WriteToDisk(gPathAndName);
end;

procedure TSurface.OnSaveAs(Sender: TObject);
var
  Done: Boolean;
  theName: string[255];
  capt, filter: AnsiString;
  pos: Integer;
begin
  if gBusy or (not gAlreadyDrawn) then
    Exit;
  Done := False;
  while not Done do begin
    SaveDialog1.FileName := '';
    if SaveDialog1.Execute then begin
      theName := SaveDialog1.FileName;
      gPathAndName := theName;
      WriteToDisk(gPathAndName);
      capt := ExtractFileName(theName);
      pos := length(capt);
      filter := copy(capt, pos - 4, 3);
      if filter = kFilter then
        surface.caption := copy(capt, 0, pos - 4)
      else
        surface.caption := capt;
    end;
    Done := True;
  end;
end;

function TSurface.CloseCurrentSurface(Sender: TObject): Boolean;
var
  res: Word;
begin
  result := False;
  if gBusy then
    Exit;
  if gAlreadyDrawn and (not gSaved) then begin
    res := MessageDlg(eWantToSaveQ, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if res = mrYes then begin
      OnSave(sender);
      if not gSaved then
        Exit;
    end
    else if res = mrCancel then
      Exit;
  end;
  result := True;
end;


procedure TSurface.CloseQueryClick(Sender: TObject; var CanClose: Boolean);
var
  res: Word;
begin
  if gBusy then
    Exit;
  if gAlreadyDrawn and (not gSaved) then begin
    res := MessageDlg(eWantToSaveQ, mtConfirmation, [mbCancel, mbNo, mbYes],
      0);
    if res = mrNo then
      CanClose := True
    else if res = mrYes then begin
      OnSave(sender);
      canClose := gSaved;
    end
    else
      canClose := False;
  end
  else
    CanClose := True;
end;

procedure TSurface.OnSignatureClick(Sender: TObject);
begin
  if gBusy then
    Exit;
  gEpsilon := -gEpsilon;
  LightRays1.Enabled := (gEpsilon = -1);
  EuclideanSpace1.Checked := (gEpsilon = 1);
  MinkowskiSpace1.Checked := (gEpsilon = -1);
end;

procedure TSurface.OnShowUnitCircle(Sender: TObject);
begin
  if gBusy then
    Exit;
  gShowUnitConic := not gShowUnitConic;
  if gShowUnitConic then
    ShowUnitCircle1.Caption := eDontShowUnitCircle
  else
    ShowUnitCircle1.Caption := eShowUnitCircle;
end;

procedure TSurface.OnDrawCube(Sender: TObject);
begin
  if gBusy then
    Exit;
  gShowCube := not gShowCube;
  Drawing3D.Invalidate;
  if gShowCube then
    DrawCube1.Caption := eRemoveCube
  else
    DrawCube1.Caption := eDrawCube;
end;

procedure TSurface.OnSidesClick(Sender: TObject);
begin
  if gBusy then
    Exit;
  gSideToDrawOn := TMenuItem(Sender).tag;
  DrawOnBothSides1.Checked := (gSideToDrawOn = 2);
  DrawOnNormalSide1.Checked := (gSideToDrawOn = 0);
  DrawOnTheOtherSide1.Checked := (gSideToDrawOn = 1);
end;

procedure TSurface.OnPickColor(Sender: TObject);
var
  c: TColor;
begin
  if gBusy then
    Exit;
  try
    if sender = ReverseColor then
      ColorDialog1.Color := cBaseGoldenPalette
    else
      ColorDialog1.Color := cBaseGreenPalette;
    if ColorDialog1.Execute then begin
      c := ColorDialog1.Color;
      if sender = ObverseColor then
        ChangeGamma(101, c)
      else
        ChangeGamma(1, c);
    end;
    if (gMode = Standard) then
      ReceiveColorMap(gStdBmp, gMap)
    else if (gMode = ColoredStereoPair) then
      ReceiveColorMap(gMovingBmp, gNormalPairMap);
    Drawing3D.invalidate;
  except
    ShowMessage(eColorDialogDidNotLoad);
  end;
end;

procedure TSurface.ChangeViewMode(Sender: TObject);
var
  lastMode: Mode;
  i: Integer;
  stdMode: Boolean;
begin
  if gBusy then
    Exit;
  lastMode := gMode;
  gMode := Mode(TMenuItem(sender).tag);
  if gMode <> lastMode then begin
    InitWatch;
    if gAlreadyDrawn then begin
      DrawButton.caption := '';
      DrawButton.Enabled := False;
    end;
    case gMode of
      standard: begin
          if lastMode in gWireModes then
            RetrieveParams;
          drawing3D.invalidate;
          drawing2D.invalidate;
        end;
      ColoredStereoPair: begin
          if lastMode in gWireModes then
            RetrieveParams;
          if gType = Implicit then
            ComputeNormalPairImplicit
          else
            ComputeNormalPairParam;
          drawing3D.invalidate;
          drawing2D.invalidate;
        end;
      Movable: begin
          if lastMode = Standard then begin
            InitSavedLines;
            InitializeClipCut;
          end;
          drawing3D.Canvas.Draw(0, 0, gStdBmp);
          if gType <> Implicit then
            drawing2D.Canvas.FillRect(gRect);
          CoordPanel.Caption:= '';
          CurvPanel.Caption := '';
          gMovingBmp.Canvas.Brush.Color := clWhite;
        end;
    else begin
        if lastMode = Standard then begin
          InitSavedLines;
          InitializeClipCut;
          CoordPanel.Caption := '';
          CurvPanel.Caption := '';
        end;
        gMovingBmp.Canvas.Brush.Color := clBlack;
        if gType = Implicit then
          ComputeWireImplicitSurface
        else
          ComputeWireParametricSurface;
        SaveParams;
        MoveSurface(gCurPtDrawing3D, gCurPtDrawing3D, []);
        if gType <> Implicit then
          drawing2D.Canvas.FillRect(gRect);
      end;
    end;
    endWatch;
    for i := 0 to ViewMode1.Count - 1 do
      viewMode1.Items[i].Checked := (ord(gMode) = viewMode1.Items[i].tag);
    stdMode := (gMode = Standard);
    Geometry1.Enabled := stdMode;
    DrawMesh1.Enabled := stdMode;
    for i := 0 to Preferences1.count - 2 do
      Preferences1.Items[i].Enabled := stdMode;
  end;
  if gMode <> Standard then begin
    CoordPanel.Caption := '';
    CurvPanel.Caption := '';
  end;
end;

procedure TSurface.OnGeometryItem(Sender: TObject);
var
  i: Integer;
  lastOption: GeomOption;
begin
  if gBusy then
    Exit;
  lastOption := gGeomOption;
  gGeomOption := GeomOption(TMenuItem(sender).tag);
  if ([lastOption, gGeomOption] * [Clipping, NormalSection] <> []) and
    (lastOption <> gGeomOption) then begin
    InitializeClipCut;
    drawing2D.Invalidate;
    drawing3D.invalidate;
    DrawButton.caption := '';
    DrawButton.update;
  end;
  case gGeomOption of
    CoordLines:
      gActiveLine := kCoordinates;
    LightRays:
      gActiveLine := kLightRays;
    Geodesics, ExponentialMap, GeodBetweenPts, LinesOfConstGeodCurv:
      gActiveLine := kIntrinsic;
    GeodesicBall:
      gActiveLine := kGeodBall;
    ParallelTransport:
      gActiveLine := kTransport;
    CurvatureLines:
      gActiveLine := kCurvature;
    AsymptoticLines:
      gActiveLine := kAsymptotics;
  else
    ;
  end;
  for i := 0 to Geometry1.count - 1 do
    Geometry1.items[i].Checked := False;
  TMenuItem(sender).Checked := True;
  if (gType <> PseudoRiemannian) and gAlreadyDrawn and (gMode = Standard) and
    (gGeomOption in [Clipping, NormalSection]) then
  begin
    PrepareToSetClip;
    if gGeomOption = Clipping then
      MoveClip(gCurPtDrawing3D, gCurPtDrawing3D);
  end;
  Inform('');
end;

procedure TSurface.OnMeshNumber(Sender: TObject);
var
  act: Integer;
begin
  if gBusy then
    Exit;
  gMeshNumber := TMenuItem(Sender).tag;
  gBusy := True;
  act := gActiveLine;
  gActiveLine := kCoordinates;
  if (gType = Implicit) then
    DrawMeshImplicitSurface
  else if (gType = Parametric) or (gType = Tube) then
    DrawMeshParamSurface;
  gBusy := False;
  gActiveLine := act;
end;

procedure TSurface.ShowCoordinates;
var
  strCoord: AnsiString;
  separator: Char;
begin
  if not gCurPtGood then begin
    CoordPanel.Caption := '';
    Exit;
  end;
  separator := DecimalSeparator;
  DecimalSeparator := '.';
  strCoord := '';
  if (gType <> Implicit) then
    strCoord := FloatToStrF(gCur2DPos[1], ffFixed, 10, 3) + #13#10 +
      FloatToStrF(
      gCur2DPos[2], ffFixed, 10, 3) + #13#10;
  if gType <> PseudoRiemannian then begin
    strCoord := strCoord + FloatToStrF(gCur3DPos[1], ffFixed, 10, 3) + #13#10;
    strCoord := strCoord + FloatToStrF(gCur3DPos[2], ffFixed, 10, 3) + #13#10;
    strCoord := strCoord + FloatToStrF(gCur3DPos[3], ffFixed, 10, 3);
  end;
  CoordPanel.Caption := strCoord;
  DecimalSeparator := separator;
end;

procedure TSurface.ShowCurvatures(calculateThem: Boolean);
var
  K: Double;
  separator: char;
  strCurv: AnsiString;
begin
  if not gCurPtGood then begin
    CurvPanel.Caption := '';
    Exit;
  end;
  separator := DecimalSeparator;
  DecimalSeparator := '.';
  if calculateThem then
    case gType of
      Parametric, Tube:
        ComputeCurvaturesParamSurface(gCur2DPos, gCur3DPos);
      Implicit:
        ComputeCurvaturesImplicitSurface(gCur3DPos);
      PseudoRiemannian:
        ComputePseudoRiemCurvature(gCur2DPos, K);
    end;
  strCurv := gKStr;
  if gType <> PseudoRiemannian then begin
    strCurv := strCurv + #13#10 + gHStr + #13#10 + gK1Str + #13#10 + gK2Str;
    CurvPanel.Caption := StrCurv;
  end
  else
    CurvPanel.Caption := gKStr;
  DecimalSeparator := separator;
end;

function TSurface.ComputeCurPointsFrom2D: Boolean;
begin
  result := False;
  if gType <> Implicit then begin
    FromDrawingToParameters(gCurPtDrawing2D, gCur2DPos);
    result := (gCur2DPos[1] >= gMin2D[1]) and (gCur2DPos[2] >= gMin2D[2])
      and
      (gCur2DPos[1] <= gMax2D[1]) and (gCur2DPos[2] <= gMax2D[2]);
    if result and (gType <> PseudoRiemannian) then begin
      theFPar2(gCur3DPos, gCur2DPos);
      result := InClips(gCur3DPos);
      if result then
        gCurPtDrawing3D := ProjectToPaneInt(gCur3DPos);
    end;
  end;
end;

function TSurface.ComputeCurPointsFrom3D: Boolean;
begin
  if gType = Implicit then
    result := PickedPtImplicit(gCurPtDrawing3D, gCur3DPos)
  else
    result := PickedPtParametric(gCurPtDrawing3D, gCur2DPos, gCur3DPos);
  if result then
    result := InClips(gCur3DPos);
  if Result and (gType <> Implicit) then
    FromParametersToDrawing(gCur2DPos, gCurPtDrawing2D);
end;

procedure TSurface.ResetPoints(sender: TPaintBox; x, y: Integer; firstTime:
  Boolean);
begin
  if not firstTime then begin
    gLastPtDrawing2D := gCurPtDrawing2D;
    gLastPtDrawing3D := gCurPtDrawing3D;
    gLast2DPos := gCur2DPos;
    gLast3DPos := gCur3DPos;
  end;
  if sender = drawing2D then begin
    gCurPtDrawing2D.x := X;
    gCurPtDrawing2D.y := Y;
    gCurPtGood := PtInRect(gRect, gCurPtDrawing2D) and
      ComputeCurPointsFrom2D;
  end
  else if sender = drawing3D then begin
    gCurPtDrawing3D.x := X;
    gCurPtDrawing3D.y := Y;
    gCurPtGood := PtInRect(gRect, gCurPtDrawing3D) and
      ComputeCurPointsFrom3D;
  end;
  if firstTime then begin
    gFirstPtGood := gCurPtGood;
    gFirst2DPos := gCur2DPos;
    gFirst3DPos := gCur3DPos;
    gFirstPtDrawing3D := gCurPtDrawing3D;
    gFirstPtDrawing2D := gCurPtDrawing2D;
  end;
end;

function TSurface.ShouldTrackMouse(sender: TPaintBox): Boolean;
begin
  case gType of
    PseudoRiemannian:
      result := gCurPtGood and ((gGeomOption in gSecondOrderOptions)
        or (gGeomOption = ParallelTransport));
    Implicit:
      if (gMode in gWireModes) then
        result := True
      else if (gMode = Standard) then begin
        result := gCurPtGood and (gGeomOption in gSecondOrderOptions +
          [NormalSection]);
        result := result or (gGeomOption = Clipping)
      end;
    Parametric, Tube:
      if (gMode in gWireModes + [Movable]) then
        result := (sender = drawing3D)
      else if (gMode = Standard) then begin
        result := (sender = drawing2D) and (gGeomOption in gSecondOrderOptions
          +
          [ParallelTransport, NormalSection]) and gCurPtGood;
        result := result or ((sender = drawing3D) and gCurPtGood and
          (gGeomOption in
          gSecondOrderOptions + [NormalSection]));
        result := result or ((sender = drawing3D) and (gGeomOption =
          Clipping));
      end;
  end;
end;

procedure TSurface.RepaintXCrossUnitCircleEtc(sender: TPaintBox);
  var
    can : TCanvas;
    nearly : Boolean;
    i, j, k : Integer;
begin
  if sender =drawing2D then begin
    can := surface.Drawing2D.canvas;
    can.Pen.Mode := pmNotXoR;
    if (gGeomOption in gXOptions) and gThereIsX2D then begin
      can.Pen.Color := clTeal;
      can.moveto(gX2D[1].x, gX2D[1].y);
      can.lineto(gX2D[2].x, gX2D[2].y);
      can.moveto(gX2D[3].x, gX2D[3].y);
      can.lineto(gX2D[4].x, gX2D[4].y);
    end;
    if ((gType = Parametric) or (gType = Tube)) and gThereIsCross2D then begin
      can.Pen.Color := clGreen;
      can.moveto(gCross2D[1].x, gCross2D[1].y);
      can.lineto(gCross2D[2].x, gCross2D[2].y);
      can.moveto(gCross2D[3].x, gCross2D[3].y);
      can.lineto(gCross2D[4].x, gCross2D[4].y);
    end;
    if (gThereIsUnitConic=1) then begin
      can.Pen.Color := gammaGrey^[2];
      nearly := (abs(gUnitConic[1].x) < 15000) and (abs(gUnitConic[1].y) <
        15000);
      if nearly then
        can.moveto(gUnitConic[1].x, gUnitConic[1].y);
      for i := 2 to 31 do begin
        if (abs(gUnitConic[i].x) < 5000) and (abs(gUnitConic[i].y) < 5000) then begin
          if nearly then begin
            can.lineto(gUnitConic[i].x, gUnitConic[i].y);
            can.lineto(gUnitConic[i].x, gUnitConic[i].y);
          end
          else begin
            can.moveto(gUnitConic[i].x, gUnitConic[i].y);
            nearly := true;
          end
        end;
      end;
    end
    else if (gThereIsUnitConic=2) then begin
      i := 0;
      for j := 0 to 3 do begin
        inc(i);
        nearly := (abs(gUnitConic[i].x) < 5000) and (abs(gUnitConic[i].y) <
          5000);
        if nearly then
          can.moveto(gUnitConic[i].x, gUnitConic[i].y);
        for k := 1 to 20 do begin
          inc(i);
          if (abs(gUnitConic[i].x) < 5000) and (abs(gUnitConic[i].y) < 5000) then begin
            if nearly then begin
              can.lineto(gUnitConic[i].x, gUnitConic[i].y);
              can.lineto(gUnitConic[i].x, gUnitConic[i].y);
            end
            else begin
              can.moveto(gUnitConic[i].x, gUnitConic[i].y);
              nearly := true;
            end;
          end;
        end;
      end;
    end;
  end
else if sender = drawing3D then begin
  if (gGeomOption in gXOptions) and gThereIsX3D then begin
    can := surface.Drawing3D.canvas;
    can.Pen.Color := clWhite;
    can.pen.Mode := pmXor;
    can.moveto(gCross3D[1].x, gCross3D[1].y);
    can.lineto(gCross3D[2].x, gCross3D[2].y);
    can.moveto(gCross3D[3].x, gCross3D[3].y);
    can.lineto(gCross3D[4].x, gCross3D[4].y);
  end;
  if  gThereIsCross3D then begin
      can := surface.Drawing3D.canvas;
      can.Pen.Color := clBlack;
      can.Pen.Mode := pmNotXor;
      can.moveto(gX3D[1].x, gX3D[1].y);
      can.lineto(gX3D[2].x, gX3D[2].y);
      can.moveto(gX3D[3].x, gX3D[3].y);
      can.lineto(gX3D[4].x, gX3D[4].y);
  end;
end;
end;


procedure TSurface.DrawXCrossUnitCircleEtc(sender: TPaintBox);
begin
  if (gMode <> Standard) then
    Exit;
  if (gGeomOption = Clipping) and (sender = drawing3D) then begin
    FindWhatToMove(gCurPtDrawing3D);
    DrawClipEllipse;
  end;
  if not gCurPtGood then begin
    EraseCross2D;
    EraseX;
    EraseUnitConic;
    coordPanel.Caption := '';
    curvPanel.Caption := '';
    Exit;
  end
  else
    ShowCoordinates;
  if gGeomOption in gXOptions then
    case gType of
      Parametric, Tube:
        DrawXParamSurface;
      Implicit:
        DrawXImplicitSurface;
      PseudoRiemannian:
        DrawXPseudoRiemPlane;
    else
      ;
    end
  else begin
    if (gType = Parametric) or (gType = Tube) then begin
      if (sender = drawing3D) then
        DrawCross2D
      else
        DrawCross3D;
    end;
  end;
  if (gGeomOption <> NormalSection) and gShowUnitConic then
    DrawUnitConic;
  if (gGeomOption in gXOptions) and (gType <> PseudoRiemannian) and gCurPtGood
    then
    ShowCurvatures(False)
  else
    ShowCurvatures(True);
end;

procedure TSurface.OnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if gBusy or (not Active) or (not gAlreadyDrawn) then
    Exit;
  ResetPoints(TPaintBox(Sender), x, y, true);
  gTracking := (Button = mbLeft) and ShouldTrackMouse(TPaintBox(sender));
  if (gTracking) then
    case gGeomOption of
      ParallelTransport:
        InitArrow(X, Y);
      Geodesics..LinesOfConstGeodCurv:
        with TPaintBox(sender).Canvas do begin
          Pen.Color := gammaPurple[7];
          Pen.Mode := pmXor;
          moveto(X, Y);
          lineto(X, Y);
          Pen.Mode := pmCopy;
        end;
    else
      ;
    end
  else if gCurPtGood and (Button = mbLeft) and (gMode = Standard) and
    (gGeomOption in (gXOptions + [coordLines])) then begin
    InitWatch;
    case gType of
      Parametric, Tube:
        DrawCurvesParamSurface(gCur2DPos);
      PseudoRiemannian:
        DrawCurvesPseudoRiemPlane(gCur2DPos);
      Implicit:
        DrawCurvesImplicitSurface(gCur3DPos);
    end;
    EndWatch;
  end;
end;

procedure TSurface.DoDraggingMouse(sender: TPaintBox; Shift: TShiftState);
var
  goodClip: Boolean;
begin
  if (sender = drawing3D) and (gMode in gWireModes + [Movable]) then
    MoveSurface(gLastPtDrawing3D, gCurPtDrawing3D, Shift)
  else if (gMode = Standard) then
    case gGeomOption of
      ParallelTransport:
        gTracking := ParallelTransportArrow(gLastPtDrawing2D,
          gCurPtDrawing2D);
      Geodesics..LinesOfConstGeodCurv:
        with sender.Canvas do begin
          Pen.Color := gammaPurple[7];
          Pen.Mode := pmXor;
          if sender = drawing2D then begin
            moveto(gFirstPtDrawing2D.X, gFirstPtDrawing2D.Y);
            lineto(gLastPtDrawing2D.X, gLastPtDrawing2D.Y);
            moveto(gFirstPtDrawing2D.X, gFirstPtDrawing2D.Y);
            lineto(gCurPtDrawing2D.X, gCurPtDrawing2D.Y);
          end
          else begin
            moveto(gFirstPtDrawing3D.X, gFirstPtDrawing3D.Y);
            lineto(gLastPtDrawing3D.X, gLastPtDrawing3D.Y);
            moveto(gFirstPtDrawing3D.X, gFirstPtDrawing3D.Y);
            lineto(gCurPtDrawing3D.X, gCurPtDrawing3D.Y);
          end;
          Pen.Mode := pmCopy;
        end;
      Clipping: if (sender = drawing3D) then
          MoveClip(gLastPtDrawing3D, gCurPtDrawing3D);
      NormalSection: begin
          if (gType = Implicit) and ComputeClipImplicitSurface(gNewClip) then
          begin
            FindClipCut;
            DrawCutImplicitSurface;
          end
          else begin
            if (sender = drawing3D) then
              goodClip := ComputeClipParamSurface(gFirstPtDrawing3D,
                gCurPtDrawing3D, true, gNewClip)
            else
              goodClip := ComputeClipParamSurface(gFirstPtDrawing2D,
                gCurPtDrawing2D, false, gNewClip);
            if goodClip then begin
              FindClipCut;
              DrawCutParamSurface(sender = drawing3D);
            end;
          end;
        end
    end;
end;

procedure TSurface.OnMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if gBusy or (not Active) or (not gAlreadyDrawn) or ((sender = drawing2D) and
    (gMode <>
    Standard)) then
    Exit;
  ResetPoints(TPaintBox(sender), x, y, false);
  if (not gTracking) then
    DrawXCrossUnitCircleEtc(TPaintBox(sender))
  else begin
    EraseCross2D;
    EraseX;
    EraseUnitConic;
  end;
  if gTracking then
    DoDraggingMouse(TPaintBox(sender), shift);
  if not PtInRect(gRect, Point(x, y)) then begin
    x := x + TPaintBox(sender).boundsRect.left;
    y := y + TPaintBox(sender).boundsRect.top;
    MovingMouseInForm(self, [], x, y);
  end;
end;

procedure TSurface.DoAfterMouseUp(Sender: TPaintBox; Shift: TShiftState; X,
  Y: Integer);
var
  goodPts: Boolean;
begin
  if (sender = drawing3D) and (gMode in gWireModes) then begin
    DrawButton.Enabled := True;
    DrawButton.caption := eRedraw;
    DrawButton.update;
  end
  else if (sender = drawing3D) and (gMode = Movable) then begin
    InitWatch;
    gAlreadyDrawn := DrawParametricSurface;
    EndWatch;
    drawing3D.Canvas.draw(0, 0, gStdBmp);
    if gShowCube then
      DrawCube(Drawing3D.Canvas);
  end;
  if (gMode = Movable) then
    Exit;
  if (gMode = Standard) then
    case gGeomOption of
      ParallelTransport:
        StoreFinalArrow(gCurPtDrawing2D);
      Geodesics..LinesOfConstGeodCurv:
        with sender.Canvas do begin
          Pen.Color := gammaPurple[7];
          Pen.Mode := pmXor;
          if sender = drawing2D then begin
            moveto(gFirstPtDrawing2D.X, gFirstPtDrawing2D.Y);
            lineto(gLastPtDrawing2D.X, gLastPtDrawing2D.Y);
          end
          else begin
            moveto(gFirstPtDrawing3D.X, gFirstPtDrawing3D.Y);
            lineto(gLastPtDrawing3D.X, gLastPtDrawing3D.Y);
          end;
          Pen.Mode := pmCopy;
          if (gType = Implicit) then
            goodPts := gFirstPtGood and ((x <> gFirstPtDrawing3D.X) or (y <>
              gFirstPtDrawing3D.y))
          else
            goodPts := gFirstPtGood and ((x <> gFirstPtDrawing2D.X) or (y <>
              gFirstPtDrawing2D.y));
          if (gGeomOption <> GeodBetweenPts) then begin
            if (gType <> Implicit) then begin
              if sender = drawing2D then
                gVel := ComputeParamVelFromDrawing2DPoints(gFirstPtDrawing2D,
                  gLastPtDrawing2D)
              else
                goodPts := goodPts and FindVelFor2OrderCurvesParamSurf(gVel);
            end
            else
              goodPts := goodPts and ComputeVelImplicitSurface(gVel, false);
          end
          else
            goodPts := goodPts and gCurPtGood;
          if goodPts then begin
            InitWatch;
            DrawSecondOrderCurve(1 - 2 * ord(ssAlt in Shift));
            EndWatch;
          end;
        end;
      Clipping: if (sender = drawing3D) then begin
          DrawButton.Enabled := True;
          DrawButton.caption := eClipIt;
          DrawButton.update;
        end;
      NormalSection: begin
          DrawButton.Enabled := True;
          DrawButton.caption := eClipIt;
          DrawButton.update;
        end;
    else
      ;
    end;
end;


procedure TSurface.OnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if gBusy or (not Active) or (not gAlreadyDrawn) or ((sender = drawing2D) and
    (gMode <>
    Standard)) or (not gTracking) then
    Exit;
  ResetPoints(TPaintBox(sender), x, y, false);
  DoAfterMouseUp(TPaintBox(Sender), Shift, X, Y);
  gTracking := False;
end;


procedure TSurface.OnRefresh(Sender: TObject);
begin
  if gBusy or (not gAlreadyDrawn) then
    Exit;
  InitSavedLines;
  drawing2D.Invalidate;
  drawing3D.invalidate;
end;

procedure TSurface.InitWatch;
begin
  gStop := False;
  gBusy := True;
  StopButton.Enabled := True;
  StopButton.Font.Color := clRed;
  StopButton.caption := eStop;
  StopButton.Repaint;
end;

procedure TSurface.EndWatch;
begin
  gStop := False;
  gBusy := False;
  with StopButton do begin
    if gType = PseudoRiemannian then begin
      Enabled := False;
      caption := '';
    end
    else begin
      if gClips <> nil then
        caption := eNoClips
      else
        caption := '';
      Enabled := (gClips <> nil);
    end;
  end;
end;


procedure TSurface.OnStopButton(Sender: TObject);
begin
  if gBusy then
    gStop := True
  else if (gType <> PseudoRiemannian) and (gClips <> nil) then begin
    gClips := nil;
    gClipTop := -1;
    OnDrawButtonClick(nil);
    StopButton.caption := '';
    StopButton.Enabled := False;
  end;
end;

procedure TSurface.OnMemoFocus(Sender: TObject);
begin
  TMemo(Sender).SelectAll
end;


procedure TSurface.MovingMouseInForm(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  pt: TPoint;
  in2D, in3D: Boolean;
begin
  pt.x := x; pt.y := y;
  in2D := ptInRect(Drawing2D.BoundsRect, pt);
  in3D := ptInRect(Drawing3D.BoundsRect, pt);
  if not in2D then
    EraseCross3D;
  if not in3D then
    EraseCross2D;
  if (not in2D) and (not in3D) then begin
    EraseX;
    EraseUnitConic;
  end;
end;

procedure TSurface.ClickOnMenuBarExecute(Sender: TObject);
begin
  EraseCross2D;
  EraseCross3D;
  EraseX;
  EraseUnitConic;
end;

procedure TSurface.OnEditFieldChange(Sender: TObject);
  var
    modif: Boolean;
    tx : AnsiString;
    i : Integer;
begin
  inherited;
  if gBusy then
    Exit;
  if (sender is TMemo) then
    modif := TMemo(Sender).Modified
  else
    modif:= TEdit(Sender).Modified;
  if modif then begin
    if (sender is TMemo) then begin
      tx := TMemo(Sender).text;
      i :=  TMemo(Sender).tag;
    end
    else  begin
      tx := TEdit(Sender).text;
      i :=  TEdit(Sender).tag;
    end;
    if Trim(tx) <> gSurfaceStr[i] then begin
      DrawButton.Enabled := True;
      DrawButton.caption := eDWDrawIt;
    end
    else if gAlreadyDrawn then begin
      DrawButton.Enabled := False;
      DrawButton.caption := '';
    end;
  end;
end;

procedure TSurface.OnPrintMenu(Sender: TObject);
var
  answer: Integer;
begin
  if gBusy or (not gAlreadyDrawn) then Exit;
  if (gMode in gWireModes) then begin
    gPrintLines := False;
    gPrintSurface := True;
    answer := mrOK;
  end
  else begin
      Form2 := TForm2.Create(nil);
    answer := Form2.ShowModal;
    Form2.Free;
  end;
{$IFDEF MSWINDOWS}
  if (answer = mrOK) and PrintDialog1.Execute then begin
{$ENDIF}
{$IFDEF LINUX}
  if (answer = mrOK) and (Printer.PrintAdapter as TQPrintAdapter).ExecuteSetup then begin
{$ENDIF}
    if (not (gMode in gWireModes)) and (gResolution > 1) and gPrintSurface then begin
      InitWatch;
      if DrawWithHighResolution then
        answer := mrOK
      else
        answer := mrCancel;
      EndWatch;
    end;
    if answer = mrOk then
      PrintAsDesired;
  end;
end;

 
procedure TSurface.OnSaveAsBitmap(Sender: TObject);
var
{$IFDEF MSWINDOWS}
  shiftState: Integer;
{$ENDIF}
{$IFDEF LINUX}
  shiftState: TShiftState;
{$ENDIF}
begin
  if gBusy or not gAlreadyDrawn then
    Exit;
  try
    gForPrintingBmp.Height := kHeight;
    gForPrintingBmp.Width := kWidth;
    gForPrintingBmp.PixelFormat := pf32bit;
    gForPrintingBmp.Canvas.Brush.Style := bsSolid;
    if gMode in gWireModes then
      gForPrintingBmp.Canvas.Brush.Color := clBlack
    else
      gForPrintingBmp.Canvas.Brush.Color := clWhite;
    gForPrintingBmp.Canvas.FillRect(gRect);
    {$IFDEF MSWINDOWS}
    shiftState := GetKeyState(VK_SHIFT);
    if (gType in [Parametric, Tube]) and (gMode = Standard) and (shiftState < 0) then
      DrawSavedLines(0)
    {$ENDIF}
    {$IFDEF LINUX}
    shiftState := Application.KeyState;
    if (gType in [Parametric, Tube]) and (gMode = Standard) and (ssShift in shiftState) then
      DrawSavedLines(0)
    {$ENDIF}
    else begin
      if (gMode in [Standard, Movable]) then begin
        gForPrintingBmp.Canvas.Draw(0, 0, gStdBmp);
        if gType = PseudoRiemannian then
          DrawSavedLines(0)
        else if (gMode = Standard) and not (gGeomOption in [NormalSection, Clipping]) then begin
          DrawSavedLines(1);
          if gShowCube then
            DrawCube(gForPrintingBmp.Canvas);
        end
      end
      else
        gForPrintingBmp.Canvas.Draw(0, 0, gMovingBmp);
    end;
    ClipBoard.Assign(gForPrintingBmp);
  finally
    ;
  end;
end;

end.
